/*
 * Copyright 2013 Victor Nazarov <asviraspossible@gmail.com>.
 */
package com.github.sviperll;

/**
 *
 * @author Victor Nazarov <asviraspossible@gmail.com>
 */
public class ConfigurablePredicate<T> implements Predicate<T> {
    private final Predicate<T> predicate;
    public ConfigurablePredicate(Predicate<T> predicate) {
        this.predicate = predicate;
    }

    @Override
    public boolean evaluate(T t) {
        return predicate.evaluate(t);
    }

    public ConfigurableFunction<T, Boolean> asFunction() {
        return Predicates.asFunction(predicate);
    }

    public ConfigurablePredicate<T> not() {
        return Predicates.not(predicate);
    }

    public ConfigurablePredicate<T> and(Predicate<T> thatPredicate) {
        return Predicates.and(this.predicate, thatPredicate);
    }

    public ConfigurablePredicate<T> or(Predicate<T> thatPredicate) {
        return Predicates.or(this.predicate, thatPredicate);
    }
}
